#ifndef RK_DNSPACK_ARGUMENT_H
#define RK_DNSPACK_ARGUMENT_H

#include <string>

namespace rk
{
	namespace dnspack
	{
		class IArgument
		{
		public:
			virtual ~IArgument() {}

		public:
			virtual const std::string& getInputFileName() const noexcept = 0;
		};

		class Argument : public IArgument
		{
		public:
			Argument();
			virtual ~Argument();

		public:
			bool parse(int argc, char* argv[]);
			void usage() noexcept;

			const std::string& getInputFileName() const noexcept;

		private:
			std::string m_inputFileName;

		private:
			Argument(const Argument& other) = delete;
			Argument(Argument&& other) noexcept = delete;
			Argument& operator=(const Argument& other) = delete;
			Argument& operator=(Argument&& other) noexcept = delete;
		};
	}
}

inline const std::string& rk::dnspack::Argument::getInputFileName() const noexcept
{
	return m_inputFileName;
}


#endif // !RK_DNSPACK_ARGUMENT_H
