#ifndef RK_DNSPACK_CLOCK_H
#define RK_DNSPACK_CLOCK_H

#include <map>
#include <string>
#include <chrono>

namespace rk
{
	namespace dnspack
	{
		class Clock
		{
		public:
			Clock();
			virtual ~Clock();

		public:
			Clock(const Clock&) = default;
			Clock(Clock&&) noexcept = default;
			Clock& operator=(const Clock&) = default;
			Clock& operator=(Clock&&) noexcept = default;

		public:
			static std::string getNowTime();

			static bool stopwatchBegin(const std::string& key);
			static bool stopwatchFinish(const std::string& key);
			static std::string getElapsedTime(const std::string& key);

		private:
			static std::map<std::string, std::chrono::time_point<std::chrono::steady_clock>> m_stopwatches;
		};
	}
}


#endif // !RK_DNSPACK_CLOCK_H
