#ifndef RK_DNSPACK_MAKECIFFILE_H
#define RK_DNSPACK_MAKECIFFILE_H

#include <string>
#include <mutex>

#include "PackingStructure.h"

namespace rk
{
    namespace dnspack
    {
        class MakeCifFile
        {
        public:
            MakeCifFile();
            virtual ~MakeCifFile();

        public:
            void operator()(const std::string& fileName, const PackingStructure& packingStructure);

        private:
            static std::mutex m_cifMutex;

        private:
            MakeCifFile(const MakeCifFile& other) = delete;
            MakeCifFile(MakeCifFile&& other) noexcept = delete;
            MakeCifFile& operator=(const MakeCifFile& other) = delete;
            MakeCifFile& operator=(MakeCifFile&& other) noexcept = delete;
        };
    }
}


#endif // !RK_DNSPACK_MAKECIFFILE_H
