#ifndef RK_DNSPACK_MAKEDIRECTORY_H
#define RK_DNSPACK_MAKEDIRECTORY_H

#include <string>

#ifdef _MSC_VER

#include <filesystem>

namespace rk
{
	namespace dnspack
	{
		class MakeDirectory
		{
		public:
			explicit MakeDirectory(const std::string& parentDirectoryPath);
			virtual ~MakeDirectory();

			bool operator()(const std::string& childDirectoryName); // If child directory already exists, return false

		private:
			const std::filesystem::path m_parentDirectoryPath;

		private:
			MakeDirectory(const MakeDirectory& other) = delete;
			MakeDirectory(MakeDirectory&& other) noexcept = delete;
			MakeDirectory& operator=(const MakeDirectory& other) = delete;
			MakeDirectory& operator=(MakeDirectory&& other) noexcept = delete;
		};
	}
}


#else

namespace rk
{
	namespace dnspack
	{
		class MakeDirectory
		{
		public:
			explicit MakeDirectory(const std::string& parentDirectoryPath);
			virtual ~MakeDirectory();

			bool operator()(const std::string& childDirectoryName);

		private:
			const std::string m_parentDirectoryPath;

		private:
			MakeDirectory(const MakeDirectory&) = delete;
			MakeDirectory(MakeDirectory&& other) noexcept = delete;
			MakeDirectory& operator=(const MakeDirectory& other) = delete;
			MakeDirectory& operator=(MakeDirectory&& other) noexcept = delete;
		};
	}
}


#endif // _MSC_VER

#endif // !RK_DNSPACK_MAKEDIRECTORY_H
