#ifndef RK_DNSPACK_PACKINGFACTORY_H
#define RK_DNSPACK_PACKINGFACTORY_H

#include <string>

#include "EnvironmentVariables.h"
#include "ExploreSchedule.h"

#include "BasisComposition.h"
#include "PackingStructure.h"
#include "CalculationAnalysis.h"
#include "SharedReporter.h"


namespace rk
{
	namespace dnspack
	{
		class PackingFactory
		{
		public:
			PackingFactory(const BasisComposition& basisComposition, const ExploreSchedule& workSchedule);
			virtual ~PackingFactory();

		public:
			PackingFactory(const PackingFactory& other) = default;
			PackingFactory(PackingFactory&& other) noexcept = default;
			PackingFactory& operator=(const PackingFactory& other) = default;
			PackingFactory& operator=(PackingFactory&& other) noexcept = default;

		public:
			void operator()();

		private:
			void execute();
			void executeWithMd();

		private:
			BasisComposition m_basisComposition;
			ExploreVariables m_exploreVariables;

			ExploreSchedule m_exploreSchedule;
			CalculationAnalysis m_calculationAnalysis;
			SharedReporter m_reportCurrentSituation;
		};
	}
}


#endif // !RK_DNSPACK_PACKINGFACTORY_H
