#ifndef RK_DNSPACK_PILINGUPGENERATE_H
#define RK_DNSPACK_PILINGUPGENERATE_H

#include "PackingStructure.h"


namespace rk
{
	namespace dnspack
	{
		class PilingUpGenerate
		{
		public:
			explicit PilingUpGenerate(const BasisComposition& basisComposition);
			virtual ~PilingUpGenerate();

		public:
			PackingStructure operator()();

		private:
			const BasisComposition& m_basisComposition;
			const std::size_t m_spheresNumber;

			double m_uniformGenerationRatio;

		private:
			PilingUpGenerate(const PilingUpGenerate& other) = delete;
			PilingUpGenerate(PilingUpGenerate&& other) noexcept = delete;
			PilingUpGenerate& operator=(const PilingUpGenerate& other) = delete;
			PilingUpGenerate& operator=(PilingUpGenerate&& other) noexcept = delete;
		};
	}
}


#endif // !RK_DNSPACK_PILINGUPGENERATE_H
