#ifndef RK_DNSPACK_REOPTIMIZEFACTORY_H
#define RK_DNSPACK_REOPTIMIZEFACTORY_H

#include <string>

#include "EnvironmentVariables.h"
#include "ReOptimizeSchedule.h"

#include "CalculationAnalysis.h"
#include "SharedReporter.h"

namespace rk
{
	namespace dnspack
	{
		class ReOptimizeFactory
		{
		public:
			explicit ReOptimizeFactory(const ReOptimizeSchedule& reOptimizeSchedule);
			virtual ~ReOptimizeFactory();

		public:
			ReOptimizeFactory(const ReOptimizeFactory& other) = default;
			ReOptimizeFactory(ReOptimizeFactory&& other) noexcept = default;
			ReOptimizeFactory& operator=(const ReOptimizeFactory& other) = default;
			ReOptimizeFactory& operator=(ReOptimizeFactory&& other) noexcept = default;

		public:
			void operator()();

		private:
			ReOptimizeVariables m_reOptimizeVariables;
			ReOptimizeSchedule m_reOptimizeSchedule;

			SharedReporter m_reportCurrentSituation;
		};
	}
}


#endif // !RK_DNSPACK_REOPTIMIZEFACTORY_H
