#ifndef RK_DNSPACK_SAMLAIDSP_H
#define RK_DNSPACK_SAMLAIDSP_H

#include <string>
#include <vector>

#include "Argument.h"
#include "BasisComposition.h"


namespace rk
{
	namespace dnspack
	{
		class SAMLAIdsp
		{
		public:
			explicit SAMLAIdsp(rk::dnspack::IArgument& argument);
			virtual ~SAMLAIdsp();

		public:
			int execute();

		private:
			void makeOutputDirectories(const std::string& outputDirectoryName, const std::vector<BasisComposition>& basisCompositions);

		private:
			rk::dnspack::IArgument& m_argument;

		private:
			SAMLAIdsp(const SAMLAIdsp& other) = delete;
			SAMLAIdsp(SAMLAIdsp&& other) noexcept = delete;
			SAMLAIdsp& operator=(const SAMLAIdsp& other) = delete;
			SAMLAIdsp& operator=(SAMLAIdsp&& other) noexcept = delete;
		};
	}
}


#endif // !RK_DNSPACK_SAMLAIDSP_H
