#ifndef RK_DNSPACK_SHAREDREPORTER_H
#define RK_DNSPACK_SHAREDREPORTER_H

#include <string>
#include <map>
#include <mutex>

namespace rk
{
	namespace dnspack
	{
		class SharedReporter
		{
		public:
			explicit SharedReporter(const std::string& fileName);
			virtual ~SharedReporter();

		public:
			SharedReporter(const SharedReporter& other);
			SharedReporter(SharedReporter&& other) noexcept;
			SharedReporter& operator=(const SharedReporter& other);
			SharedReporter& operator=(SharedReporter&& other) noexcept;

		public:
			void report(const std::string& message) const;

		private:
			static std::mutex m_reportMutex;
			static std::map<std::string, int> m_sharedNumbers;

		private:
			std::string m_fileName;
		};
	}
}


#endif // !RK_DNSPACK_SHAREDREPORTER_H
