#ifndef RK_DNSPACK_SPHERELABEL_H
#define RK_DNSPACK_SPHERELABEL_H

namespace rk
{
	namespace dnspack
	{
		class SphereLabel
		{
		public:
			int Qa;
			int Qb;
			int Qc;
			int sphereIndex;

		public:
			SphereLabel(const SphereLabel& other) = default;
			SphereLabel(SphereLabel&& other) noexcept = default;
			SphereLabel& operator=(const SphereLabel& other) = default;
			SphereLabel& operator=(SphereLabel&& other) noexcept = default;

			bool operator==(const SphereLabel& other) const;
			bool operator!=(const SphereLabel& other) const;
		};
	}
}

inline bool rk::dnspack::SphereLabel::operator==(const rk::dnspack::SphereLabel& other) const
{
	return (Qa == other.Qa && Qb == other.Qb && Qc == other.Qc && sphereIndex == other.sphereIndex);
}

inline bool rk::dnspack::SphereLabel::operator!=(const rk::dnspack::SphereLabel& other) const
{
	return !(*this == other);
}


#endif // !RK_DNSPACK_SPHERELABEL_H
