#ifndef RK_DNSPACK_TASKMANAGER_H
#define RK_DNSPACK_TASKMANAGER_H

#include <string>

#include "EnvironmentVariables.h"
#include "BasisComposition.h"

namespace rk
{
	namespace dnspack
	{
		class TaskManager
		{
		public:
			TaskManager(const BasisComposition& basisComposition, const std::string& resultDirectoryName, const std::string& densestPackingsDirectoryName);
			virtual ~TaskManager();

		public:
			int execute();

		private:
			const BasisComposition m_basisComposition;
			const std::string m_resultDirectoryName;
			const std::string m_densestPackingsDirectoryName;

			EnvironmentVariables m_environmentVariables;

		private:
			TaskManager(const TaskManager&) = delete;
			TaskManager(TaskManager&&) noexcept = delete;
			TaskManager& operator=(const TaskManager&) = delete;
			TaskManager& operator=(TaskManager&&) noexcept = delete;
		};
	}
}


#endif // !RK_DNSPACK_TASKMANAGER_H
