#ifndef RK_DNSPACK_UNIQUEREPORTER_H
#define RK_DNSPACK_UNIQUEREPORTER_H

#include <string>

namespace rk
{
	namespace dnspack
	{
		class UniqueReporter
		{
		public:
			explicit UniqueReporter(const std::string& fileName);
			virtual ~UniqueReporter();

		public:
			void report(const std::string& message) const;

		private:
			const std::string m_fileName;

		private:
			UniqueReporter(const UniqueReporter& other) = delete;
			UniqueReporter(UniqueReporter&& other) noexcept = delete;
			UniqueReporter& operator=(const UniqueReporter& other) = delete;
			UniqueReporter& operator=(UniqueReporter&& other) noexcept = delete;
		};
	}
}


#endif // !RK_DNSPACK_UNIQUEREPORTER_H
