#include "BasisComposition.h"

using namespace rk::dnspack;

BasisComposition::BasisComposition()
	: m_composition()
{
}

BasisComposition::BasisComposition(const std::map<double, int>& composition)
	: m_composition(composition)
{
	for (const auto& number : m_composition)
	{
		if (number.first <= 0.0)
		{
			throw std::invalid_argument("composition has a minus radius.");
		}

		if (number.second <= 0)
		{
			throw std::invalid_argument("composition has a minus number of each sphere in an unit cell.");
		}
	}
}

BasisComposition::BasisComposition(std::map<double, int>&& composition)
	: m_composition()
{
	for (const auto& number : m_composition)
	{
		if (number.first <= 0.0)
		{
			throw std::invalid_argument("composition has a minus radius.");
		}

		if (number.second <= 0)
		{
			throw std::invalid_argument("composition has a minus number of each sphere in an unit cell.");
		}
	}

	m_composition = std::move(composition);
}

BasisComposition::~BasisComposition()
{
}
