#include "ExploreSchedule.h"

#include <stdexcept>

#include "EnvironmentVariables.h"

using namespace rk::dnspack;


std::mutex ExploreSchedule::m_scheduleMutex;

int ExploreSchedule::m_initialSupplyingNumber;
int ExploreSchedule::m_initialDemandNumber;
int ExploreSchedule::m_supplyingNumber = 0;
int ExploreSchedule::m_demandNumber = 0;

double ExploreSchedule::m_maxPackingFraction = 0.0;
std::multimap<double, PackingStructure> ExploreSchedule::m_densePackingStructures;
int ExploreSchedule::m_maxPackingFractionStructureNumber;


ExploreSchedule::ExploreSchedule(const std::string& resultDirectory)
	: m_resultDirectory{ resultDirectory }
	, m_resultDirectoryForDatFiles{ resultDirectory + "DatFiles/" }
	, m_resultDirectoryForCifFiles{ resultDirectory + "CifFiles/" }
{
	EnvironmentVariables environmentVariables;

	m_fullOptimizeStructureNumber = environmentVariables.getExploreVariables().getFullOptimizeStructureNumber();
	m_maxTrialNumber = environmentVariables.getExploreVariables().getMaxTrialNumber();
	m_thresholdTrialNumber = environmentVariables.getExploreVariables().getThresholdTrialNumber();
	m_outputMinimumPackingFraction = environmentVariables.getExploreVariables().getOutputMinimumPackingFraction();
	m_outputMinimumZ = environmentVariables.getExploreVariables().getOutputMinimumZ();
	m_outputMdFile = environmentVariables.getExploreVariables().outputMdFile();
	m_densePackingStructureNumber = environmentVariables.getReOptimizeVariables().getReOptimizeStructureNumber();
	m_threadNumber = environmentVariables.getThreadNumber();

	if (m_resultDirectory.empty())
	{
		throw std::logic_error("m_resultDirectory is empty.");
	}
}

ExploreSchedule::~ExploreSchedule()
{
}
