#include "IsDirectory.h"

using namespace rk::dnspack;


IsDirectory::IsDirectory()
{
}

IsDirectory::~IsDirectory()
{
}


#ifdef _MSC_VER

#include <filesystem>

bool IsDirectory::operator()(const std::string& directoryName)
{
	const std::filesystem::path directoryPath(directoryName);	
	return (std::filesystem::is_directory(directoryPath));
}


#else

#include <sys/stat.h>

bool IsDirectory::operator()(const std::string& directoryName)
{
	struct stat s;
	stat(directoryName.c_str(), &s);

	return (S_ISDIR(s.st_mode));
}


#endif // _MSC_VER
