#include "ReOptimizeSchedule.h"

#include <stdexcept>

#include "EnvironmentVariables.h"

using namespace rk::dnspack;


std::mutex ReOptimizeSchedule::m_scheduleMutex;

int ReOptimizeSchedule::m_supplyingNumber = 0;
int ReOptimizeSchedule::m_demandNumber = 0;
double ReOptimizeSchedule::m_maxPackingFraction = 0.0;


ReOptimizeSchedule::ReOptimizeSchedule(const PackingStructure& seedStructure, const std::string& densestPackingsDirectory)
	: m_seedStructure(seedStructure)
	, m_densestPackingsDirectory{ densestPackingsDirectory }
	, m_densestPackingsDirectoryForDatFiles{ densestPackingsDirectory + "DatFiles/" }
	, m_densestPackingsDirectoryForCifFiles{ densestPackingsDirectory + "CifFiles/" }
{
	EnvironmentVariables environmentVariables;

	m_reOptimizeRepetitionNumber = environmentVariables.getReOptimizeVariables().getReOptimizeRepetitionNumber();
	m_outputMinimumZ = environmentVariables.getReOptimizeVariables().getOutputMinimumZ();
	m_threadNumber = environmentVariables.getThreadNumber();

	if (m_seedStructure.uninitialized())
	{
		throw std::logic_error("ReOptimizeSchedule::m_seedStructure is uninitialized.");
	}

	if (m_densestPackingsDirectory.empty())
	{
		throw std::logic_error("densestPackingsDirectory is empty.");
	}
}

ReOptimizeSchedule::~ReOptimizeSchedule()
{
}
