#include "Restart.h"

#include <fstream>
#include <sstream>
#include <regex>

using namespace rk::dnspack;


Restart::Restart(const std::string& resultFileName)
	: m_resultFileName{ resultFileName }
{
}

Restart::~Restart()
{
}

bool Restart::readResultFile(double& maxPackingFraction)
{
	double maximumPackingFraction = 0.0;

// ******************************************************************************************************************************************
	// Read input file

	std::string fileString;
	{
		std::ifstream inputFileStream;
		inputFileStream.open(m_resultFileName, std::ios_base::in);

		if (!inputFileStream)
		{
			return false;
		}

		else
		{
			for (std::string stringLine; std::getline(inputFileStream, stringLine);)
			{
				fileString += stringLine + "\n";
			}

			inputFileStream.close();
		}
	}

	// Read input file
// ******************************************************************************************************************************************


	std::regex pat("[\\n][\\s]*Maximum.Packing.Fraction[\\s]+([\\d]+[\\.]?[\\d]*)[\\s]*");
	std::smatch numSm;

	if (std::regex_search(fileString, numSm, pat))
	{
		maximumPackingFraction = std::stod(numSm.str(1));

		if (1.0 < maximumPackingFraction)
		{
			throw std::logic_error("Maximum.Packing.Fraction is more than one.");
		}

		else if (maximumPackingFraction < 0.0)
		{
			throw std::logic_error("Maximum.Packing.Fraction is less than zero.");
		}

		else
		{
			maxPackingFraction = maximumPackingFraction;
			return true;
		}
	}

	else
	{
		return false;
	}
}
