#include "Sphere.h"

#include <cmath>

using namespace rk::dnspack;

Sphere::Sphere() noexcept
	: m_radius{ 0 }
	, m_fractionalCoordinate()
{
}

Sphere::Sphere(const double radius)
	: m_radius{ radius }
	, m_fractionalCoordinate()
{
	if (m_radius <= 0)
	{
		throw std::invalid_argument("radius should be larger than 0.");
	}
}

Sphere::~Sphere()
{
}

Sphere::Sphere(const Sphere& other) noexcept
	: m_radius{ other.m_radius }
	, m_fractionalCoordinate(other.m_fractionalCoordinate)
{
}

Sphere::Sphere(Sphere&& other) noexcept
	: m_radius{ other.m_radius }
	, m_fractionalCoordinate(std::move(other.m_fractionalCoordinate))
{
}
