#include "UniqueReporter.h"

#include <fstream>

using namespace rk::dnspack;


UniqueReporter::UniqueReporter(const std::string& fileName)
	: m_fileName{ fileName }
{
	std::ofstream outputFileStream;
	outputFileStream.open(m_fileName, std::ios_base::out);

	if (!outputFileStream)
	{
		std::string message = "couldn't open the file of ";
		message += m_fileName;
		message += ".";

		throw std::invalid_argument(message);
	}

	outputFileStream.close();
}

UniqueReporter::~UniqueReporter()
{
}


#ifdef _MSC_VER

#include <iostream>


void UniqueReporter::report(const std::string& message) const
{
	std::cout << message;

	std::ofstream outputFileStream;
	outputFileStream.open(m_fileName, std::ios_base::app);

	if (!outputFileStream)
	{
		std::string message = "couldn't open the file of ";
		message += m_fileName;
		message += ".";

		throw std::invalid_argument(message);
	}

	outputFileStream << message;
	outputFileStream.close();
}


#else

void UniqueReporter::report(const std::string& message) const
{
	std::ofstream outputFileStream;
	outputFileStream.open(m_fileName, std::ios_base::app);

	if (!outputFileStream)
	{
		std::string message = "couldn't open the file of ";
		message += m_fileName;
		message += ".";

		throw std::invalid_argument(message);
	}

	outputFileStream << message;
	outputFileStream.close();
}


#endif // _MSC_VER
